import { decl, scope } from "./scope.js";
const ifThen = (test, truthy, falsey) => ({
  tag: "if",
  type: "void",
  test,
  t: scope(truthy),
  f: falsey ? scope(falsey) : void 0
});
const ternary = (test, t, f) => ({
  tag: "ternary",
  type: t.type,
  test,
  t,
  f
});
function forLoop(...xs) {
  const [init, test, iter, body] = xs.length === 2 ? [, xs[0], , xs[1]] : xs.length === 3 ? [xs[0], xs[1], , xs[2]] : xs;
  return {
    tag: "for",
    type: "void",
    init: init ? decl(init) : void 0,
    test: test(init),
    iter: iter ? iter(init) : void 0,
    scope: scope(body(init))
  };
}
const whileLoop = (test, body) => ({
  tag: "while",
  type: "void",
  test,
  scope: scope(body)
});
const ctrl = (id) => ({
  tag: "ctrl",
  type: "void",
  id
});
const brk = ctrl("break");
const cont = ctrl("continue");
const discard = ctrl("discard");
export {
  brk,
  cont,
  discard,
  forLoop,
  ifThen,
  ternary,
  whileLoop
};
